<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package multi_blogger
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function multi_blogger_body_classes( $classes ) {
  global $multi_blogger_post;
  
    if( !is_page_template( 'template-home.php' ) ){
        $classes[] = 'inner';
        // Adds a class of group-blog to blogs with more than 1 published author.
    }

    if ( is_multi_author() ) {
        $classes[] = 'group-blog ';
    }

    // Adds a class of custom-background-image to sites with a custom background image.
    if ( get_background_image() ) {
        $classes[] = 'custom-background-image';
    }
    
    // Adds a class of custom-background-color to sites with a custom background color.
    if ( get_background_color() != 'ffffff' ) {
        $classes[] = 'custom-background-color';
    }
    

    if( multi_blogger_woocommerce_activated() && ( is_shop() || is_product_category() || is_product_tag() || 'product' === get_post_type() ) && ! is_active_sidebar( 'shop-sidebar' ) ){
        $classes[] = 'full-width';
    }    

    // Adds a class of hfeed to non-singular pages.
    if ( ! is_page() ) {
        $classes[] = 'hfeed ';
    }
  
    if( is_404() ||  is_search() ){
        $classes[] = 'full-width';
    }
  
    if( ! is_active_sidebar( 'right-sidebar' ) ) {
        $classes[] = 'full-width'; 
    }

    return $classes;
}
add_filter( 'body_class', 'multi_blogger_body_classes' );

 /**
 * 
 * @link http://www.altafweb.com/2011/12/remove-specific-tag-from-php-string.html
 */
function multi_blogger_strip_single( $tag, $string ){
    $string=preg_replace('/<'.$tag.'[^>]*>/i', '', $string);
    $string=preg_replace('/<\/'.$tag.'>/i', '', $string);
    return $string;
}

if ( ! function_exists( 'multi_blogger_excerpt_more' ) ) :
/**
 * Replaces "[...]" (appended to automatically generated excerpts) with ... * 
 */
function multi_blogger_excerpt_more($more) {
  return is_admin() ? $more : ' &hellip; ';
}
endif;
add_filter( 'excerpt_more', 'multi_blogger_excerpt_more' );


if( ! function_exists( 'multi_blogger_footer_credit' ) ):
/**
 * Footer Credits
*/
function multi_blogger_footer_credit() {

    // Check if footer copyright is enabled
    $multi_blogger_show_footer_copyright = get_theme_mod( 'multi_blogger_footer_setting', true );

    if ( ! $multi_blogger_show_footer_copyright ) {
        return; 
    }

    $multi_blogger_copyright_text = get_theme_mod('multi_blogger_footer_copyright_text');

    $multi_blogger_text = '<div class="site-info"><div class="container"><span class="copyright">';
    if ($multi_blogger_copyright_text) {
        $multi_blogger_text .= wp_kses_post($multi_blogger_copyright_text); 
    } else {
        $multi_blogger_text .= esc_html__('&copy; ', 'multi-blogger') . date_i18n(esc_html__('Y', 'multi-blogger')); 
        $multi_blogger_text .= ' <a href="' . esc_url(home_url('/')) . '">' . esc_html(get_bloginfo('name')) . '</a>' . esc_html__('. All Rights Reserved.', 'multi-blogger');
    }
    $multi_blogger_text .= '</span>';
    $multi_blogger_text .= '<span class="by"> <a href="' . esc_url('https://www.themeignite.com/products/multi-blogger') . '" rel="nofollow" target="_blank">' . MULTI_BLOGGER_THEME_NAME . '</a>' . esc_html__(' By ', 'multi-blogger') . '<a href="' . esc_url('https://themeignite.com/') . '" rel="nofollow" target="_blank">' . esc_html__('Themeignite', 'multi-blogger') . '</a>.';
    /* translators: %s: link to WordPress.org */
    $multi_blogger_text .= sprintf(esc_html__(' Powered By %s', 'multi-blogger'), '<a href="' . esc_url(__('https://wordpress.org/', 'multi-blogger')) . '" target="_blank">WordPress</a>.');
    if (function_exists('the_privacy_policy_link')) {
        $multi_blogger_text .= get_the_privacy_policy_link();
    }
    $multi_blogger_text .= '</span></div></div>';
    echo apply_filters('multi_blogger_footer_text', $multi_blogger_text);
}
add_action('multi_blogger_footer', 'multi_blogger_footer_credit');
endif;

/**
 * Is Woocommerce activated
*/
if ( ! function_exists( 'multi_blogger_woocommerce_activated' ) ) {
  function multi_blogger_woocommerce_activated() {
    if ( class_exists( 'woocommerce' ) ) { return true; } else { return false; }
  }
}

if( ! function_exists( 'multi_blogger_change_comment_form_default_fields' ) ) :
/**
 * Change Comment form default fields i.e. author, email & url.
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function multi_blogger_change_comment_form_default_fields( $fields ){    
    // get the current commenter if available
    $multi_blogger_commenter = wp_get_current_commenter();
 
    // core functionality
    $req      = get_option( 'require_name_email' );
    $multi_blogger_aria_req = ( $req ? " aria-required='true'" : '' );
    $multi_blogger_required = ( $req ? " required" : '' );
    $multi_blogger_author   = ( $req ? __( 'Name*', 'multi-blogger' ) : __( 'Name', 'multi-blogger' ) );
    $multi_blogger_email    = ( $req ? __( 'Email*', 'multi-blogger' ) : __( 'Email', 'multi-blogger' ) );
 
    // Change just the author field
    $fields['author'] = '<p class="comment-form-author"><label class="screen-reader-text" for="author">' . esc_html__( 'Name', 'multi-blogger' ) . '<span class="required">*</span></label><input id="author" name="author" placeholder="' . esc_attr( $multi_blogger_author ) . '" type="text" value="' . esc_attr( $multi_blogger_commenter['comment_author'] ) . '" size="30"' . $multi_blogger_aria_req . $multi_blogger_required . ' /></p>';
    
    $fields['email'] = '<p class="comment-form-email"><label class="screen-reader-text" for="email">' . esc_html__( 'Email', 'multi-blogger' ) . '<span class="required">*</span></label><input id="email" name="email" placeholder="' . esc_attr( $multi_blogger_email ) . '" type="text" value="' . esc_attr(  $multi_blogger_commenter['comment_author_email'] ) . '" size="30"' . $multi_blogger_aria_req . $multi_blogger_required. ' /></p>';
    
    $fields['url'] = '<p class="comment-form-url"><label class="screen-reader-text" for="url">' . esc_html__( 'Website', 'multi-blogger' ) . '</label><input id="url" name="url" placeholder="' . esc_attr__( 'Website', 'multi-blogger' ) . '" type="text" value="' . esc_attr( $multi_blogger_commenter['comment_author_url'] ) . '" size="30" /></p>'; 
    
    return $fields;    
}
endif;
add_filter( 'comment_form_default_fields', 'multi_blogger_change_comment_form_default_fields' );

if( ! function_exists( 'multi_blogger_change_comment_form_defaults' ) ) :
/**
 * Change Comment Form defaults
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function multi_blogger_change_comment_form_defaults( $defaults ){    
    $defaults['comment_field'] = '<p class="comment-form-comment"><label class="screen-reader-text" for="comment">' . esc_html__( 'Comment', 'multi-blogger' ) . '</label><textarea id="comment" name="comment" placeholder="' . esc_attr__( 'Comment', 'multi-blogger' ) . '" cols="45" rows="8" aria-required="true" required></textarea></p>';
    
    return $defaults;    
}
endif;
add_filter( 'comment_form_defaults', 'multi_blogger_change_comment_form_defaults' );

if( ! function_exists( 'multi_blogger_escape_text_tags' ) ) :
/**
 * Remove new line tags from string
 *
 * @param $text
 * @return string
 */
function multi_blogger_escape_text_tags( $text ) {
    return (string) str_replace( array( "\r", "\n" ), '', strip_tags( $text ) );
}
endif;

if( ! function_exists( 'wp_body_open' ) ) :
/**
 * Fire the wp_body_open action.
 * Added for backwards compatibility to support pre 5.2.0 WordPress versions.
*/
function wp_body_open() {
    /**
     * Triggered after the opening <body> tag.
    */
    do_action( 'wp_body_open' );
}
endif;

if ( ! function_exists( 'multi_blogger_get_fallback_svg' ) ) :    
/**
 * Get Fallback SVG
*/
function multi_blogger_get_fallback_svg( $multi_blogger_post_thumbnail ) {
    if( ! $multi_blogger_post_thumbnail ){
        return;
    }
    
    $multi_blogger_image_size = multi_blogger_get_image_sizes( $multi_blogger_post_thumbnail );
     
    if( $multi_blogger_image_size ){ ?>
        <div class="svg-holder">
             <svg class="fallback-svg" viewBox="0 0 <?php echo esc_attr( $multi_blogger_image_size['width'] ); ?> <?php echo esc_attr( $multi_blogger_image_size['height'] ); ?>" preserveAspectRatio="none">
                    <rect width="<?php echo esc_attr( $multi_blogger_image_size['width'] ); ?>" height="<?php echo esc_attr( $multi_blogger_image_size['height'] ); ?>" style="fill:#dedddd;"></rect>
            </svg>
        </div>
        <?php
    }
}
endif;

function multi_blogger_enqueue_google_fonts() {

    require get_template_directory() . '/inc/wptt-webfont-loader.php';

    wp_enqueue_style(
        'google-fonts-bebas-neue',
        multi_blogger_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Bebas+Neue&display=swap' ),
        array(),
        '1.0'
    );

    wp_enqueue_style(
        'google-fonts-unbounded',
        multi_blogger_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Unbounded:wght@200..900&display=swap' ),
        array(),
        '1.0'
    );
}
add_action( 'wp_enqueue_scripts', 'multi_blogger_enqueue_google_fonts' );


if( ! function_exists( 'multi_blogger_site_branding' ) ) :
/**
 * Site Branding
*/
function multi_blogger_site_branding(){
    $multi_blogger_logo_site_title = get_theme_mod( 'header_site_title', 1 );
    $multi_blogger_tagline = get_theme_mod( 'header_tagline', false );

    ?>
    <div class="site-branding img">
        <?php 
        // Check if custom logo is set and display it
        if (function_exists('has_custom_logo') && has_custom_logo()) {
            the_custom_logo();
        }
        if ($multi_blogger_logo_site_title):
             if (is_front_page()): ?>
            <h1 class="site-title" style="font-size: <?php echo esc_attr(get_theme_mod('multi_blogger_site_title_size', '25')); ?>px;">
            <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
          </h1>
            <?php else: ?>
                <p class="site-title" itemprop="name">
                    <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
                </p>
            <?php endif; ?>
        <?php endif; 
    
        if ($multi_blogger_tagline) :
            $multi_blogger_description = get_bloginfo('description', 'display');
            if ($multi_blogger_description || is_customize_preview()) :
        ?>
                <p class="site-description" itemprop="description"><?php echo $multi_blogger_description; ?></p>
            <?php endif;
        endif;
        ?>
    </div>
    <?php
}
endif;
if( ! function_exists( 'multi_blogger_navigation' ) ) :
    /**
     * Site Navigation
    */
    function multi_blogger_navigation(){
        ?>
        <nav class="main-navigation" id="site-navigation" role="navigation">
            <?php 
            wp_nav_menu( array( 
                'theme_location' => 'primary', 
                'menu_id' => 'primary-menu' 
            ) ); 
            ?>
        </nav>
        <?php
    }
endif;

if( ! function_exists( 'multi_blogger_header' ) ) :
    /**
     * Header Start
    */
    function multi_blogger_header(){
        $multi_blogger_header_image = get_header_image();
        $multi_blogger_sticky_header = get_theme_mod('multi_blogger_sticky_header');
        $multi_blogger_header_setting     = get_theme_mod( 'multi_blogger_header_setting', false );
        ?>
        <div id="page-site-header" class="main-header">
            <header id="masthead" class="site-header header-inner" role="banner">
                <div class="theme-menu head_bg" <?php echo $multi_blogger_header_image != '' ? 'style="background-image: url(' . esc_url( $multi_blogger_header_image ) . '); background-repeat: no-repeat; background-size: cover"': ""; ?> data-sticky="<?php echo esc_attr( $multi_blogger_sticky_header ); ?>">
                    <div class="row menu-bg">
                        <div class="col-xl-2 col-lg-2 col-md-5 col-md-left align-self-center d-flex justify-content-center align-items-center">
                            <?php multi_blogger_site_branding(); ?>
                        </div>
                        <div class="col-xl-9 col-lg-9 col-md-1 align-self-center">
                            <?php multi_blogger_navigation(); ?> 
                        </div>
                        <div class="col-xl-1 col-lg-1 col-md-6 d-flex justify-content-end">
                            <!-- Search Icon -->
                            <?php if ( get_theme_mod('multi_blogger_show_hide_search', false) != '' ) : ?>
                                <div class="search-body text-center text-md-center">
                                    <button type="button" class="search-show">
                                        <span class="search-btn"><?php echo esc_html( __( 'Search', 'multi-blogger' ) ); ?></span>
                                    </button>
                                </div>
                            <?php endif; ?>
                            <!-- Social Icon -->
                            <?php if ( get_theme_mod('multi_blogger_show_hide_search', false) != '' ) : ?>
                                <div class="searchform-inner">
                                    <?php get_search_form(); ?>
                                    <button type="button" class="close" aria-label="<?php esc_attr_e('Close', 'multi-blogger'); ?>">
                                        <span aria-hidden="true"><?php echo esc_html( 'X' ); ?></span>
                                    </button>
                                </div>
                            <?php endif; ?>
                        </div>
                    </div>
                </div>                 
            </header>
        </div>
        <?php
    }
endif;
add_action( 'multi_blogger_header', 'multi_blogger_header', 20 );
